window.Gleam.initSearch([{"doc":"postgresql_protocol","title":"postgresql_protocol","content":"","url":"index.html"},{"doc":"postgresql_protocol","title":"BackendMessage","content":"pub type BackendMessage {\n  BeBindComplete\n  BeCloseComplete\n  BeCommandComplete(Command, Int)\n  BeCopyData(data: BitArray)\n  BeCopyDone\n  BeAuthenticationOk\n  BeAuthenticationKerberosV5\n  BeAuthenticationCleartextPassword\n  BeAuthenticationMD5Password(salt: BitArray)\n  BeAuthenticationGSS\n  BeAuthenticationGSSContinue(auth_data: BitArray)\n  BeAuthenticationSSPI\n  BeAuthenticationSASL(mechanisms: List(String))\n  BeAuthenticationSASLContinue(data: BitArray)\n  BeAuthenticationSASLFinal(data: BitArray)\n  BeReadyForQuery(TransactionStatus)\n  BeRowDescriptions(List(RowDescriptionField))\n  BeMessageDataRow(List(BitArray))\n  BeBackendKeyData(process_id: Int, secret_key: Int)\n  BeParameterStatus(name: String, value: String)\n  BeCopyResponse(\n    direction: CopyDirection,\n    overall_format: Format,\n    codes: List(Format),\n  )\n  BeNegotiateProtocolVersion(\n    newest_minor: Int,\n    unrecognized_options: List(String),\n  )\n  BeNoData\n  BeNoticeResponse(set.Set(ErrorOrNoticeField))\n  BeNotificationResponse(\n    process_id: Int,\n    channel: String,\n    payload: String,\n  )\n  BeParameterDescription(List(Int))\n  BeParseComplete\n  BePortalSuspended\n  BeErrorResponse(set.Set(ErrorOrNoticeField))\n}\n Messages originating from the PostgreSQL backend (server)\nBeBindComplete\n\n\nBeCloseComplete\n\n\nBeCommandComplete(Command, Int)\n\n\nBeCopyData(data: BitArray)\n\n\nBeCopyDone\n\n\nBeAuthenticationOk\n\n\nBeAuthenticationKerberosV5\n\n\nBeAuthenticationCleartextPassword\n\n\nBeAuthenticationMD5Password(salt: BitArray)\n\n\nBeAuthenticationGSS\n\n\nBeAuthenticationGSSContinue(auth_data: BitArray)\n\n\nBeAuthenticationSSPI\n\n\nBeAuthenticationSASL(mechanisms: List(String))\n\n\nBeAuthenticationSASLContinue(data: BitArray)\n\n\nBeAuthenticationSASLFinal(data: BitArray)\n\n\nBeReadyForQuery(TransactionStatus)\n\n\nBeRowDescriptions(List(RowDescriptionField))\n\n\nBeMessageDataRow(List(BitArray))\n\n\nBeBackendKeyData(process_id: Int, secret_key: Int)\n\n\nBeParameterStatus(name: String, value: String)\n\n\nBeCopyResponse(\n  direction: CopyDirection,\n  overall_format: Format,\n  codes: List(Format),\n)\n\n\nBeNegotiateProtocolVersion(\n  newest_minor: Int,\n  unrecognized_options: List(String),\n)\n\n\nBeNoData\n\n\nBeNoticeResponse(set.Set(ErrorOrNoticeField))\n\n\nBeNotificationResponse(\n  process_id: Int,\n  channel: String,\n  payload: String,\n)\n\n\nBeParameterDescription(List(Int))\n\n\nBeParseComplete\n\n\nBePortalSuspended\n\n\nBeErrorResponse(set.Set(ErrorOrNoticeField))\n\n\nSynonyms:\npostgresql_protocol.BackendMessage\npostgresql_protocol BackendMessage","url":"postgresql_protocol.html#BackendMessage"},{"doc":"postgresql_protocol","title":"Command","content":"pub type Command {\n  Insert\n  Delete\n  Update\n  Merge\n  Select\n  Move\n  Fetch\n  Copy\n}\n\nInsert\n\n\nDelete\n\n\nUpdate\n\n\nMerge\n\n\nSelect\n\n\nMove\n\n\nFetch\n\n\nCopy\n\n\nSynonyms:\npostgresql_protocol.Command\npostgresql_protocol Command","url":"postgresql_protocol.html#Command"},{"doc":"postgresql_protocol","title":"Connection","content":"pub type Connection {\n  Connection(socket: mug.Socket, buffer: BitArray, timeout: Int)\n}\n\nConnection(socket: mug.Socket, buffer: BitArray, timeout: Int)\n\n\nSynonyms:\npostgresql_protocol.Connection\npostgresql_protocol Connection","url":"postgresql_protocol.html#Connection"},{"doc":"postgresql_protocol","title":"CopyDirection","content":"pub type CopyDirection {\n  In\n  Out\n  Both\n}\n Direction of a BeCopyResponse\nIn\n\n\nOut\n\n\nBoth\n\n\nSynonyms:\npostgresql_protocol.CopyDirection\npostgresql_protocol CopyDirection","url":"postgresql_protocol.html#CopyDirection"},{"doc":"postgresql_protocol","title":"DataRow","content":"pub type DataRow {\n  DataRow(List(BitArray))\n}\n\nDataRow(List(BitArray))\n\n\nSynonyms:\npostgresql_protocol.DataRow\npostgresql_protocol DataRow","url":"postgresql_protocol.html#DataRow"},{"doc":"postgresql_protocol","title":"ErrorOrNoticeField","content":"pub type ErrorOrNoticeField {\n  Code(String)\n  Detail(String)\n  File(String)\n  Hint(String)\n  Line(String)\n  Message(String)\n  Position(String)\n  Routine(String)\n  SeverityLocalized(String)\n  Severity(String)\n  Where(String)\n  Column(String)\n  DataType(String)\n  Constraint(String)\n  InternalPosition(String)\n  InternalQuery(String)\n  Schema(String)\n  Table(String)\n  Unknown(key: BitArray, value: String)\n}\n\nCode(String)\n\n\nDetail(String)\n\n\nFile(String)\n\n\nHint(String)\n\n\nLine(String)\n\n\nMessage(String)\n\n\nPosition(String)\n\n\nRoutine(String)\n\n\nSeverityLocalized(String)\n\n\nSeverity(String)\n\n\nWhere(String)\n\n\nColumn(String)\n\n\nDataType(String)\n\n\nConstraint(String)\n\n\nInternalPosition(String)\n\n\nInternalQuery(String)\n\n\nSchema(String)\n\n\nTable(String)\n\n\nUnknown(key: BitArray, value: String)\n\n\nSynonyms:\npostgresql_protocol.ErrorOrNoticeField\npostgresql_protocol ErrorOrNoticeField","url":"postgresql_protocol.html#ErrorOrNoticeField"},{"doc":"postgresql_protocol","title":"FeAmbigous","content":"pub type FeAmbigous {\n  FeGssResponse(data: BitArray)\n  FeSaslInitialResponse(name: String, data: BitArray)\n  FeSaslResponse(data: BitArray)\n  FePasswordMessage(password: String)\n}\n\nFeGssResponse(data: BitArray)\n\n\nFeSaslInitialResponse(name: String, data: BitArray)\n\n\nFeSaslResponse(data: BitArray)\n\n\nFePasswordMessage(password: String)\n\n\nSynonyms:\npostgresql_protocol.FeAmbigous\npostgresql_protocol FeAmbigous","url":"postgresql_protocol.html#FeAmbigous"},{"doc":"postgresql_protocol","title":"Format","content":"pub type Format {\n  Text\n  Binary\n}\n Indicates encoding of column values\nText\n\n\nBinary\n\n\nSynonyms:\npostgresql_protocol.Format\npostgresql_protocol Format","url":"postgresql_protocol.html#Format"},{"doc":"postgresql_protocol","title":"FormatValue","content":"pub type FormatValue {\n  FormatAllText\n  FormatAll(Format)\n  Formats(List(Format))\n}\n Lists of parameters can have different encodings.\nFormatAllText\n\n\nFormatAll(Format)\n\n\nFormats(List(Format))\n\n\nSynonyms:\npostgresql_protocol.FormatValue\npostgresql_protocol FormatValue","url":"postgresql_protocol.html#FormatValue"},{"doc":"postgresql_protocol","title":"FrontendMessage","content":"pub type FrontendMessage {\n  FeBind(\n    portal: String,\n    statement_name: String,\n    parameter_format: FormatValue,\n    parameters: ParameterValues,\n    result_format: FormatValue,\n  )\n  FeCancelRequest(process_id: Int, secret_key: Int)\n  FeClose(what: What, name: String)\n  FeCopyData(data: BitArray)\n  FeCopyDone\n  FeCopyFail(error: String)\n  FeDescribe(what: What, name: String)\n  FeExecute(portal: String, return_row_count: Int)\n  FeFlush\n  FeFunctionCall(\n    object_id: Int,\n    argument_format: FormatValue,\n    arguments: ParameterValues,\n    result_format: Format,\n  )\n  FeGssEncRequest\n  FeParse(\n    name: String,\n    query: String,\n    parameter_object_ids: List(Int),\n  )\n  FeQuery(query: String)\n  FeStartupMessage(params: List(#(String, String)))\n  FeSslRequest\n  FeTerminate\n  FeSync\n  FeAmbigous(FeAmbigous)\n}\n\nFeBind(\n  portal: String,\n  statement_name: String,\n  parameter_format: FormatValue,\n  parameters: ParameterValues,\n  result_format: FormatValue,\n)\n\n\nFeCancelRequest(process_id: Int, secret_key: Int)\n\n\nFeClose(what: What, name: String)\n\n\nFeCopyData(data: BitArray)\n\n\nFeCopyDone\n\n\nFeCopyFail(error: String)\n\n\nFeDescribe(what: What, name: String)\n\n\nFeExecute(portal: String, return_row_count: Int)\n\n\nFeFlush\n\n\nFeFunctionCall(\n  object_id: Int,\n  argument_format: FormatValue,\n  arguments: ParameterValues,\n  result_format: Format,\n)\n\n\nFeGssEncRequest\n\n\nFeParse(\n  name: String,\n  query: String,\n  parameter_object_ids: List(Int),\n)\n\n\nFeQuery(query: String)\n\n\nFeStartupMessage(params: List(#(String, String)))\n\n\nFeSslRequest\n\n\nFeTerminate\n\n\nFeSync\n\n\nFeAmbigous(FeAmbigous)\n\n\nSynonyms:\npostgresql_protocol.FrontendMessage\npostgresql_protocol FrontendMessage","url":"postgresql_protocol.html#FrontendMessage"},{"doc":"postgresql_protocol","title":"MessageDecodingError","content":"pub type MessageDecodingError {\n  MessageDecodingError(String)\n  MessageIncomplete(BitArray)\n  UnknownMessage(data: BitArray)\n}\n\nMessageDecodingError(String)\n\n\nMessageIncomplete(BitArray)\n\n\nUnknownMessage(data: BitArray)\n\n\nSynonyms:\npostgresql_protocol.MessageDecodingError\npostgresql_protocol MessageDecodingError","url":"postgresql_protocol.html#MessageDecodingError"},{"doc":"postgresql_protocol","title":"ParameterValue","content":"pub type ParameterValue {\n  Parameter(BitArray)\n  Null\n}\n\nParameter(BitArray)\n\n\nNull\n\n\nSynonyms:\npostgresql_protocol.ParameterValue\npostgresql_protocol ParameterValue","url":"postgresql_protocol.html#ParameterValue"},{"doc":"postgresql_protocol","title":"ParameterValues","content":"pub type ParameterValues =\n  List(ParameterValue)\n\n\nSynonyms:\npostgresql_protocol.ParameterValues\npostgresql_protocol ParameterValues","url":"postgresql_protocol.html#ParameterValues"},{"doc":"postgresql_protocol","title":"ReadError","content":"pub type ReadError {\n  SocketError(mug.Error)\n  ReadDecodeError(MessageDecodingError)\n}\n\nSocketError(mug.Error)\n\n\nReadDecodeError(MessageDecodingError)\n\n\nSynonyms:\npostgresql_protocol.ReadError\npostgresql_protocol ReadError","url":"postgresql_protocol.html#ReadError"},{"doc":"postgresql_protocol","title":"RowDescriptionField","content":"pub type RowDescriptionField {\n  RowDescriptionField(\n    name: String,\n    table_oid: Int,\n    attr_number: Int,\n    data_type_oid: Int,\n    data_type_size: Int,\n    type_modifier: Int,\n    format_code: Int,\n  )\n}\n\nRowDescriptionField(\n  name: String,\n  table_oid: Int,\n  attr_number: Int,\n  data_type_oid: Int,\n  data_type_size: Int,\n  type_modifier: Int,\n  format_code: Int,\n)\n\n\nSynonyms:\npostgresql_protocol.RowDescriptionField\npostgresql_protocol RowDescriptionField","url":"postgresql_protocol.html#RowDescriptionField"},{"doc":"postgresql_protocol","title":"StartupFailed","content":"pub type StartupFailed {\n  StartupFailedWithUnexpectedMessage(BackendMessage)\n  StartupFailedWithError(ReadError)\n}\n\nStartupFailedWithUnexpectedMessage(BackendMessage)\n\n\nStartupFailedWithError(ReadError)\n\n\nSynonyms:\npostgresql_protocol.StartupFailed\npostgresql_protocol StartupFailed","url":"postgresql_protocol.html#StartupFailed"},{"doc":"postgresql_protocol","title":"State","content":"pub type State {\n  State(\n    process_id: Int,\n    secret_key: Int,\n    parameters: dict.Dict(String, String),\n    oids: dict.Dict(Int, fn(BitArray) -&gt; Result(Int, Nil)),\n  )\n}\n\nState(\n  process_id: Int,\n  secret_key: Int,\n  parameters: dict.Dict(String, String),\n  oids: dict.Dict(Int, fn(BitArray) -&gt; Result(Int, Nil)),\n)\n\n\nSynonyms:\npostgresql_protocol.State\npostgresql_protocol State","url":"postgresql_protocol.html#State"},{"doc":"postgresql_protocol","title":"StateInitial","content":"pub type StateInitial {\n  StateInitial(parameters: dict.Dict(String, String))\n}\n\nStateInitial(parameters: dict.Dict(String, String))\n\n\nSynonyms:\npostgresql_protocol.StateInitial\npostgresql_protocol StateInitial","url":"postgresql_protocol.html#StateInitial"},{"doc":"postgresql_protocol","title":"TransactionStatus","content":"pub type TransactionStatus {\n  TransactionStatusIdle\n  TransactionStatusInTransaction\n  TransactionStatusFailed\n}\n\nTransactionStatusIdle\n\n\nTransactionStatusInTransaction\n\n\nTransactionStatusFailed\n\n\nSynonyms:\npostgresql_protocol.TransactionStatus\npostgresql_protocol TransactionStatus","url":"postgresql_protocol.html#TransactionStatus"},{"doc":"postgresql_protocol","title":"What","content":"pub type What {\n  PreparedStatement\n  Portal\n}\n\nPreparedStatement\n\n\nPortal\n\n\nSynonyms:\npostgresql_protocol.What\npostgresql_protocol What","url":"postgresql_protocol.html#What"},{"doc":"postgresql_protocol","title":"protocol_version","content":"pub const protocol_version: BitArray = &lt;&lt;\n  protocol_version_major:bits,\n  protocol_version_minor:bits,\n&gt;&gt;\n\nSynonyms:\npostgresql_protocol.protocol_version\npostgresql_protocol protocol_version","url":"postgresql_protocol.html#protocol_version"},{"doc":"postgresql_protocol","title":"protocol_version_major","content":"pub const protocol_version_major: BitArray = &lt;&lt;3:16&gt;&gt;\n\nSynonyms:\npostgresql_protocol.protocol_version_major\npostgresql_protocol protocol_version_major","url":"postgresql_protocol.html#protocol_version_major"},{"doc":"postgresql_protocol","title":"protocol_version_minor","content":"pub const protocol_version_minor: BitArray = &lt;&lt;0:16&gt;&gt;\n\nSynonyms:\npostgresql_protocol.protocol_version_minor\npostgresql_protocol protocol_version_minor","url":"postgresql_protocol.html#protocol_version_minor"},{"doc":"postgresql_protocol","title":"connect","content":"pub fn connect(\n  host: String,\n  port: Int,\n  timeout: Int,\n) -&gt; Connection\n\nSynonyms:\npostgresql_protocol.connect\npostgresql_protocol connect","url":"postgresql_protocol.html#connect"},{"doc":"postgresql_protocol","title":"decode_backend_message","content":"pub fn decode_backend_message(\n  binary: BitArray,\n) -&gt; Result(BackendMessage, MessageDecodingError)\n\nSynonyms:\npostgresql_protocol.decode_backend_message\npostgresql_protocol decode_backend_message","url":"postgresql_protocol.html#decode_backend_message"},{"doc":"postgresql_protocol","title":"decode_backend_packet","content":"pub fn decode_backend_packet(\n  packet: BitArray,\n) -&gt; Result(#(BackendMessage, BitArray), MessageDecodingError)\n\nSynonyms:\npostgresql_protocol.decode_backend_packet\npostgresql_protocol decode_backend_packet","url":"postgresql_protocol.html#decode_backend_packet"},{"doc":"postgresql_protocol","title":"decode_frontend_message","content":"pub fn decode_frontend_message(\n  binary: BitArray,\n) -&gt; Result(FrontendMessage, MessageDecodingError)\n decode a frontend message (also see decode_frontend_packet for messages that\n can&#39;t be decoded here)\nSynonyms:\npostgresql_protocol.decode_frontend_message\npostgresql_protocol decode_frontend_message","url":"postgresql_protocol.html#decode_frontend_message"},{"doc":"postgresql_protocol","title":"decode_frontend_packet","content":"pub fn decode_frontend_packet(\n  packet: BitArray,\n) -&gt; Result(#(FrontendMessage, BitArray), MessageDecodingError)\n decode a single message from the packet buffer.\n note that FeCancelRequest, FeSslRequest, FeGssEncRequest, and\n FeStartupMessage messages can only be decoded here because they don&#39;t follow\n the standard message format.\nSynonyms:\npostgresql_protocol.decode_frontend_packet\npostgresql_protocol decode_frontend_packet","url":"postgresql_protocol.html#decode_frontend_packet"},{"doc":"postgresql_protocol","title":"encode_backend_message","content":"pub fn encode_backend_message(\n  message: BackendMessage,\n) -&gt; BitArray\n\nSynonyms:\npostgresql_protocol.encode_backend_message\npostgresql_protocol encode_backend_message","url":"postgresql_protocol.html#encode_backend_message"},{"doc":"postgresql_protocol","title":"encode_frontend_message","content":"pub fn encode_frontend_message(\n  message: FrontendMessage,\n) -&gt; BitArray\n\nSynonyms:\npostgresql_protocol.encode_frontend_message\npostgresql_protocol encode_frontend_message","url":"postgresql_protocol.html#encode_frontend_message"},{"doc":"postgresql_protocol","title":"receive","content":"pub fn receive(\n  conn: Connection,\n) -&gt; Result(#(Connection, BackendMessage), ReadError)\n Receive a single message from the backend\nSynonyms:\npostgresql_protocol.receive\npostgresql_protocol receive","url":"postgresql_protocol.html#receive"},{"doc":"postgresql_protocol","title":"send","content":"pub fn send(\n  conn: Connection,\n  message: BitArray,\n) -&gt; Result(Connection, Error)\n Send a message to the database\nSynonyms:\npostgresql_protocol.send\npostgresql_protocol send","url":"postgresql_protocol.html#send"},{"doc":"postgresql_protocol","title":"send_builder","content":"pub fn send_builder(\n  conn: Connection,\n  message: BytesBuilder,\n) -&gt; Result(Connection, Error)\n Send a message to the database\nSynonyms:\npostgresql_protocol.send_builder\npostgresql_protocol send_builder","url":"postgresql_protocol.html#send_builder"},{"doc":"postgresql_protocol","title":"start","content":"pub fn start(\n  conn: Connection,\n  params: List(#(String, String)),\n) -&gt; #(Connection, State)\n\nSynonyms:\npostgresql_protocol.start\npostgresql_protocol start","url":"postgresql_protocol.html#start"},{"doc":"postgresql_protocol","title":"postgresql_protocol","content":" This library parses and generates packages for the PostgreSQL Binary Protocol\n It also provides a basic connection abstraction, but this hasn&#39;t been used\n outside of tests.","url":"postgresql_protocol.html"}]);